#!/bin/sh
#

#
# main()
#

# Source function library.
if [ -f /etc/rc.d/init.d/functions ]
then
	. /etc/rc.d/init.d/functions
elif [ -f /etc/rc.status ]
then
	. /etc/rc.status
elif [ -f /lib/lsb/init-functions ]
then
        . /lib/lsb/init-functions
fi

. /opt/nec/clusterpro/bin/clpfunctions

PATH=/sbin:/bin:/usr/sbin:/usr/bin:/opt/nec/clusterpro/bin
LD_LIBRARY_PATH=/opt/nec/clusterpro/lib
MALLOC_CHECK_=2

export PATH
export LD_LIBRARY_PATH
export MALLOC_CHECK_

# See how we were called.
case "$1" in
  start)
	targetos=`/bin/uname`

	clp_filedel "$1" init_trn $targetos
	clp_logwrite "$1" "clusterpro_trn start process start." init_trn

	# SSS
	if [ -f /opt/nec/clusterpro/bin/clpsss ]
	then
		clp_logwrite "$1" "clpsss start." init_trn
		pids=`/opt/nec/clusterpro/bin/clpsss 2>&1`
		clp_logwrite "$1" "clpsss end." init_trn
	fi

	#
	cd /opt/nec/clusterpro/bin

	#
		log_begin_msg "Starting clusterpro trnsv"

	#
	clp_logwrite "$1" "clppidof start." init_trn
	pids=`/opt/nec/clusterpro/bin/clppidof /opt/nec/clusterpro/bin/clpmonp --trnsv 2>&1`
	clp_logwrite "$1" "clppidof end.(pids=${pids})" init_trn

	if [ "$pids" != "" ]
	then
		clp_logwrite "$1" "trnsv already exist." init_trn
		clp_logwrite "$1" "clusterpro_trn start process end." init_trn
		clp_success $targetos
		exit 0
	fi

	# starting clusterpro trnsv
	clp_logwrite "$1" "trnsv start process start." init_trn
	./clpmonp --trnsv -a 2 -r 0 -w 0 > /dev/null 2>&1
	monp_ret=$?
	clp_logwrite "$1" "trnsv start process end.("$monp_ret")" init_trn

	clp_checkerr "$monp_ret" $targetos
	chk_ret=$?
	if [ "$chk_ret" = "1" ]
	then
		clp_logwrite "$1" "clusterpro_trn start process end." init_trn
		exit 0
	fi

	clp_logwrite "$1" "clusterpro_trn start process end." init_trn
	log_end_msg $?
	;;
  stop)
	targetos=`/bin/uname`

	clp_filedel "$1" init_trn $targetos
	clp_logwrite "$1" "clusterpro_trn stop process start." init_trn

	#
	log_begin_msg "Shutting down clusterpro trnsv"

	#
	cd /opt/nec/clusterpro/bin

	#
	clp_logwrite "$1" "clppidof start." init_trn
	pids=`/opt/nec/clusterpro/bin/clppidof /opt/nec/clusterpro/bin/clpmonp --trnsv 2>&1`
	clp_logwrite "$1" "clppidof end.(pids=${pids})" init_trn

	if [ "$pids" != "" ]
	then
		# shutting down clusterpro trnsv
		clp_logwrite "$1" "trnsv stop process start." init_trn
		if [ "$targetos" = "SunOS" ]
		then
			kill -17 "$pids" 2>/dev/null
			kill_ret=$?
		else
			kill -12 "$pids" 2>/dev/null
			kill_ret=$?
		fi
		clp_logwrite "$1" "trnsv stop process end.("$kill_ret")" init_trn

		i=0
		while [ "$i" -lt "10" ]
		do
			clp_logwrite "$1" "clppidof2 start." init_trn
			pids=`/opt/nec/clusterpro/bin/clppidof /opt/nec/clusterpro/bin/clpmonp --trnsv 2>&1`
			clp_logwrite "$1" "clppidof2 end.(pids=${pids})" init_trn

			if [ "$pids" = "" ]
			then
				clp_logwrite "$1" "trnsv stop success." init_trn
				clp_success $targetos

				clp_logwrite "$1" "clusterpro_trn stop process end." init_trn
				log_end_msg $?
				exit 0
			fi

			sleep 1
			i=`expr "$i" + 1`
		done

		clp_logwrite "$1" "trnsv stop timeout." init_trn
	else
		clp_logwrite "$1" "trnsv not exist." init_trn
		clp_success $targetos

		clp_logwrite "$1" "clusterpro_trn stop process end." init_trn
		log_end_msg $?
		exit 0
	fi

	clp_logwrite "$1" "clusterpro_trn stop process end." init_trn
	clp_success $targetos
	exit 0
	;;
  restart)
	$0 stop
	if [ "$?" != "0" ]
	then
		exit 1
	fi

	sleep 1
	$0 start
	;;
  status)
	targetos=`/bin/uname`
	if [ "$targetos" = "SunOS" ]
	then
		clp_status_s clptrnsv
	else
		clp_status clptrnsv
	fi
	;;
  *)
	echo "Usage: $0 {start|stop|restart|status}"
	exit 1
	;;
esac

exit 0
